libgdamm Reference Documentation

Main Page Namespaces Book

# Gnome::Gda::DataHandler Class Reference
[Data Handlers]

Base class which provides data handling capabilities. More...

Inheritance diagram for Gnome::Gda::DataHandler:

[legend]
List of all members.

## Public Member Functions

bool | accepts_g_type (GType type) const
| Checks wether the GdaDataHandler is able to handle the gda type given as argument.
Glib::ustring | get_descr () const
| Get a short description of the GdaDataHandler.
GType | get_g_type_index (guint index) const
| Get the GType handled by the GdaDataHandler, at the given position (starting at zero).
unsigned int | get_nb_g_types () const
| Get the number of GType types the GdaDataHandler can handle correctly.
Value | get_sane_init_value (GType type) const
| Creates a new Value which holds a sane initial value to be used if no value is specifically provided.
Glib::ustring | get_sql_from_value (const Value& value) const
| Creates a new string which is an SQL representation of the given value.
Glib::ustring | get_str_from_value (const Value& value) const
| Creates a new string which is a "user friendly" representation of the given value (in the users's locale, specially for the dates).
Value | get_value_from_sql (const Glib::ustring& sql, GType type) const
| Creates a new Value which represents the SQL value given as argument.
Value | get_value_from_str (const Glib::ustring& str, GType type) const
| Creates a new Value which represents the STR value given as argument.
const GdaDataHandler* | gobj () const
| Provides access to the underlying C GObject.
GdaDataHandler* | gobj ()
| Provides access to the underlying C GObject.
virtual | ~DataHandler ()

## Static Public Member Functions

static void | add_interface (GType gtype_implementer)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gnome::Gda::DataHandler> | wrap (GdaDataHandler* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Base class which provides data handling capabilities.

Because data types vary a lot from one DBMS to another, the DataHandler interface helps with designing modules which can handle very specific pieces of data through plugins. Each object which imlements the DataHandler interface is expected to handle a subset of the possible libgda defined data types.

The DataHandler object can convert a Value to and from both SQL and 'STR'. The SQL representation of a value is the actual string which would be used in an SQL statement (for example a string's SQL representation is surrounded by quotes such as 'that a string''). The 'STR' representation is a user friendly representation of a value (and the previous example would simply be: that's a string).

Only one object which implements this interface is needed for any given data type, and it mainly contains some methods to manage values (as Value structures). The Gnome::Db::DataEntry interface is complementary to this one since it is implemented by widgets in which the user can enter or modify some data.

## Constructor & Destructor Documentation

virtual Gnome::Gda::DataHandler::~DataHandler | ( |  | ) | `[virtual]`

## Member Function Documentation

bool Gnome::Gda::DataHandler::accepts_g_type | ( | GType | type | ) | const

Checks wether the GdaDataHandler is able to handle the gda type given as argument.

Returns:
  `true` if the gda type can be handled.

static void Gnome::Gda::DataHandler::add_interface | ( | GType | gtype_implementer | ) | `[static]`

Glib::ustring Gnome::Gda::DataHandler::get_descr | ( |  | ) | const

Get a short description of the GdaDataHandler.

Returns:
  The description.

GType Gnome::Gda::DataHandler::get_g_type_index | ( | guint | index | ) | const

Get the GType handled by the GdaDataHandler, at the given position (starting at zero).

Returns:
  The GType.

unsigned int Gnome::Gda::DataHandler::get_nb_g_types | ( |  | ) | const

Get the number of GType types the GdaDataHandler can handle correctly.

Returns:
  The number.

Value Gnome::Gda::DataHandler::get_sane_init_value | ( | GType | type | ) | const

Creates a new Value which holds a sane initial value to be used if no value is specifically provided.

For example, for a simple string, this would return a new value containing the "" string.

Parameters:

  | type |

Returns:
  The new Value.

Glib::ustring Gnome::Gda::DataHandler::get_sql_from_value | ( | const Value& | value | ) | const

Creates a new string which is an SQL representation of the given value.

If the value is `0` or is of type GDA_TYPE_`0`, the returned string is `0`.

Parameters:

  | value | The value to be converted to a string.

Returns:
  The new string.

Glib::ustring Gnome::Gda::DataHandler::get_str_from_value | ( | const Value& | value | ) | const

Creates a new string which is a "user friendly" representation of the given value (in the users's locale, specially for the dates).

If the value is `0` or is of type GDA_TYPE_`0`, the returned string is a copy of "" (empty string).

Parameters:

  | value | The value to be converted to a string.

Returns:
  The new string.

Value Gnome::Gda::DataHandler::get_value_from_sql | ( | const Glib::ustring & | sql,
|  | GType | type |
| ) |  |  | const

Creates a new Value which represents the SQL value given as argument.

This is the opposite of the function get_sql_from_value(). The type argument is used to determine the real data type requested for the returned value.

If the sql string is empty, then the returned Value is of type TYPE_NULL. If the sql string does not correspond to a valid SQL string for the requested type, then a NULL Value is returned.

Parameters:

  | sql |
  | type |

Returns:
  The new Value.

Value Gnome::Gda::DataHandler::get_value_from_str | ( | const Glib::ustring & | str,
|  | GType | type |
| ) |  |  | const

Creates a new Value which represents the STR value given as argument.

This is the opposite of the function get_str_from_value(). The type argument is used to determine the real data type requested for the returned value.

If the str string is empty, then the returned Value is of type TYPE_NULL. If the str string does not correspond to a valid STR string for the requested type, then a NULL value is returned.

Parameters:

  | str |
  | type |

Returns:
  The new Value.

const GdaDataHandler* Gnome::Gda::DataHandler::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gnome::Gda::HandlerBin, Gnome::Gda::HandlerBoolean, Gnome::Gda::HandlerNumerical, Gnome::Gda::HandlerString, Gnome::Gda::HandlerTime, and Gnome::Gda::HandlerType.

GdaDataHandler* Gnome::Gda::DataHandler::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gnome::Gda::HandlerBin, Gnome::Gda::HandlerBoolean, Gnome::Gda::HandlerNumerical, Gnome::Gda::HandlerString, Gnome::Gda::HandlerTime, and Gnome::Gda::HandlerType.

## Friends And Related Function Documentation

Glib::RefPtr<Gnome::Gda::DataHandler> wrap | ( | GdaDataHandler * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- datahandler.h